#include <iostream>
using namespace std;

class A
{
public:
    A() { cout << "A()" << endl; }
    A(const A& other) { cout << "A(const A&)" << endl; }
    ~A() { cout << "~A()" << endl; }
    A& operator=(const A& other)
    {
        cout << "A::operator=(const A&)" << endl;
        return *this;
    }
};

class B
{
public:
    B() { cout << "B()" << endl; }
    B(const B& other) { cout << "B(const B&)" << endl; }
    B(const A& a) { cout  << "B(const A&)" << endl; }
    ~B() { cout << "~B()" << endl; }
    B& operator=(const B& other)
    {
        cout << "B::operator=(const B&)" << endl;
        return *this;
    }
};

B g_b;

A func()
{
    cout << "func() start" << endl;
    A retval;
    cout << "func() middle" << endl;
    return retval;
}


int main()
{
    g_b = true ? func() : B();
}
